[![pub package](https://img.shields.io/pub/v/getwidget.svg)](https://pub.dartlang.org/packages/getwidget) [![Build Status](https://travis-ci.org/ionicfirebaseapp/getwidget.svg?branch=master)](https://travis-ci.com/ionicfirebaseapp/getwidget) [![Open Source Love](https://badges.frapsoft.com/os/v1/open-source.svg?v=102)](https://opensource.org/licenses/MIT) [![License](https://img.shields.io/badge/license-MIT-orange.svg)](https://github.com/ionicfirebaseapp/getwidget/blob/master/LICENSE) [![Twitter Follow](https://img.shields.io/twitter/follow/getwidgetdev.svg?style=social)](https://twitter.com/getwidgetdev)

<p align="center">
  <a href="https://www.getwidget.dev/" target="_blank">
    <img src="https://ik.imagekit.io/ionicfirebaseapp/logo.black_iOBoLWdj2I.png" alt="GetWidget Flutter UI KIT Library">
  </a>
</p>

[**GetWidget**](https://www.getwidget.dev) is a 100% free Flutter open-source UI Kit library built with <a href="https://flutter.dev/" target="_blank">Flutter SDK</a> to make Flutter development easier and more joyful than ever. GetWidget has 1000+ pre-build widgets that you can reuse to develop both Flutter mobile app and web app. Our motto is to provide the best Flutter UI library to the Flutter community to speed up their development process and build awesome apps with pre-build Flutter Library Components.

## Table of contents 

- [Screenshot](#screenshot)
- [Quick start](#quick-start)
- [Features](#features)
- [Demo](#demo)
- [Contributing](#contributing)
- [Documentation](#documentation)
- [Copyright and license](#copyright-and-license)
- [Marketplace](https://market.getwidget.dev/)

 
 ## Screenshot
 <p align="center">
  <a target="_blank" href="https://docs.getwidget.dev/">
    <img src="https://ik.imagekit.io/h9hq9qdx8/getwidget/GitHub_Image.webp" alt="GetWidget UI KIT Collection">
  </a>
</p>



## Quick start

Read the [Getting started page](https://docs.getwidget.dev) 
Forum [Support and discussion ](https://forum.getwidget.dev)

## Features 
we have launched the library with the following components :   

[GETWIDGET WIDGET COLLECTION](https://www.getwidget.dev/features)
 
 #### [Flutter Button Widget](https://docs.getwidget.dev/gf-button) |  [Flutter Elevated Button Widget](https://docs.getwidget.dev/gf-button/standard-button) | [Flutter Rounded Button Widget](https://docs.getwidget.dev/gf-button/pills-button) | [Flutter Square Button Widget](https://docs.getwidget.dev/gf-button/square-button) | [Flutter Icon Button Widget](https://docs.getwidget.dev/gf-button/icon-button) | [Flutter Social Button Widget](https://docs.getwidget.dev/gf-button/social-button) | [Flutter Badge Widget](https://docs.getwidget.dev/gf-badge) |  [Flutter Avatar Widget](https://docs.getwidget.dev/gf-avatar) |  [Flutter Image Widget](https://docs.getwidget.dev/gf-image) |  [Flutter Card Widget](https://docs.getwidget.dev/gf-card) |  [Flutter Carousel Widget](https://docs.getwidget.dev/gf-carousel) | [Flutter Tile Widget](https://docs.getwidget.dev/gf-tile) | [Flutter Tabbar Widget](https://docs.getwidget.dev/gf-tab) | [Flutter Typography](https://docs.getwidget.dev/gf-typography) | [Flutter Toaster Widget](https://docs.getwidget.dev/gf-toast) | [Flutter Switch Toggle Widget](https://docs.getwidget.dev/gf-toggle) | [Flutter Drawer Widget](https://docs.getwidget.dev/gf-drawer) | [Flutter Accordian Widget](https://docs.getwidget.dev/gf-accordion) | [Flutter Alert Widget](https://docs.getwidget.dev/gf-alert) | [Flutter Appbar Widget](https://docs.getwidget.dev/gf-appbar) | [Flutter Searchbar Widget](https://docs.getwidget.dev/gf-searchbar) | [Flutter Floating Widget](https://docs.getwidget.dev/gf-floating-widget) | [Flutter Rating Widget](https://docs.getwidget.dev/gf-rating) | [Flutter Dropdown Widget](https://docs.getwidget.dev/gf-dropdown) | [Flutter Loader Widget](https://docs.getwidget.dev/gf-loader) | [Flutter Progress Bar Widget](https://docs.getwidget.dev/gf-progress-bar) | [Flutter Shimmer Widget](https://docs.getwidget.dev/gf-shimmer) |  [Flutter Animation Widget](https://docs.getwidget.dev/gf-animation) |  [Flutter Border Widget](https://docs.getwidget.dev/gf-border) |  [Flutter Bottomsheet Widget](https://docs.getwidget.dev/gf-bottomsheet) |  [Flutter Checkbox Widget](https://docs.getwidget.dev/gf-checkbox) |  [Flutter CheckboxListTile Widget](https://docs.getwidget.dev/gf-checkbox-listtile) |  [Flutter Radio Button Widget](https://docs.getwidget.dev/gf-radio) |  [Flutter Radio ListTile Widget](https://docs.getwidget.dev/gf-radio-listtile) | [Flutter Sticky Header Widget](https://docs.getwidget.dev/gf-radio-listtile) 
 
 
 ## Demo 
 
   ### Play Store 
   <p align="left">
        <a href="https://play.google.com/store/apps/details?id=dev.getflutter.appkit" target="_blank">
          <img src="https://ik.imagekit.io/ionicfirebaseapp/tr:dpr-auto,tr:w-auto/playstore_NQQBiJIQ1.png" alt="GetWidget playstore Demo">
        </a>
      </p>
 
 ### An Open-Source News App Built With GetWidget & Flutter
 Ionicfirebaseapp.com has been developed an open-source News Mobile App with GetWidget, So can start building app faster to get an overview and do customization. You can Download News App Souce Code here: https://www.ionicfirebaseapp.com/products 
 ## Contributing
 
  GetWidget is **100% free** and **open source**. We encourage and support an active, healthy community that accepts contributions from the public &ndash; including you. There are a couple of ways in which you can contribute to the growing community of `getwidget`.
  
  * Pick up any issue marked with ["good first issue"](https://github.com/ionicfirebaseapp/getwidget/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22)
  * Fix a bug
  * Write and improve some **documentation**. Documentation is very critical to us. We would appreciate help in adding multiple languages to our docs.
  * If you are a developer, feel free to check out the source and submit pull requests.
  * Dig into [**CONTRIBUTING.MD**](CONTRIBUTING.md), which covers submitting bugs, requesting new features, preparing your code for a pull request, etc.
  * Please don't forget to **like**, **follow**, and **star our repo**! Join our growing [community](https://forum.getwidget.dev) to keep up to date with the latest GetWidget development. 
 
 
 
 ##  Flutter Getwidget Documentation 
 
  [**Installation Guide**](https://docs.getwidget.dev)
  
 
### Social Media

Twitter: <https://twitter.com/getwidgetdev>

Facebook: <https://www.facebook.com/getwidget>

Linkedin: <https://www.linkedin.com/showcase/getwidget/>

Instagram: <https://www.instagram.com/getwidgetdev/> 

 
 ## Copyright-and-license 
 Code and documentation Copyright 2017-2020 the [GETWIDGET Authors](https://www.getwidget.dev) and [IONICFIREBASEAPP](https://ionicfirebaseapp.com) Code released under the [MIT License]. Docs released under [Creative Commons](https://creativecommons.org/licenses/by/3.0/).

## Contributors

### Code Contributors

This project exists thanks to all the people who contribute. [[Contribute](CONTRIBUTING.md)].
<a href="https://github.com/ionicfirebaseapp/getwidget/graphs/contributors"><img src="https://opencollective.com/getwidget/contributors.svg?width=890&button=false" /></a>

### Financial Contributors

Become a financial contributor and help us sustain our community. [[Contribute](https://opencollective.com/getwidget/contribute)]

#### Individuals

<a href="https://opencollective.com/getwidget"><img src="https://opencollective.com/getwidget/individuals.svg?width=890"></a>

#### Organizations

Support this project with your organization. Your logo will show up here with a link to your website. [[Contribute](https://opencollective.com/getwidget/contribute)]

<a href="https://opencollective.com/getwidget/organization/0/website"><img src="https://opencollective.com/getwidget/organization/0/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/1/website"><img src="https://opencollective.com/getwidget/organization/1/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/2/website"><img src="https://opencollective.com/getwidget/organization/2/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/3/website"><img src="https://opencollective.com/getwidget/organization/3/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/4/website"><img src="https://opencollective.com/getwidget/organization/4/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/5/website"><img src="https://opencollective.com/getwidget/organization/5/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/6/website"><img src="https://opencollective.com/getwidget/organization/6/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/7/website"><img src="https://opencollective.com/getwidget/organization/7/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/8/website"><img src="https://opencollective.com/getwidget/organization/8/avatar.svg"></a>
<a href="https://opencollective.com/getwidget/organization/9/website"><img src="https://opencollective.com/getwidget/organization/9/avatar.svg"></a>
